/**CHeaderFile*****************************************************************

  FileName    [TraceXmlLoader.h]

  PackageName [trace.loaders]

  Synopsis    [The header file for the TraceXmlLoader class]

  Description []

  SeeAlso     []

  Author      [Marco Pensallorto]

  Copyright   [
  This file is part of the ``trace.plugins'' package of NuSMV version 2.
  Copyright (C) 2010 by FBK-irst.

  NuSMV version 2 is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  NuSMV version 2 is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA.

  For more information on NuSMV see <http://nusmv.fbk.eu>
  or email to <nusmv-users@fbk.eu>.
  Please report bugs to <nusmv-users@fbk.eu>.

  To contact the NuSMV development board, email to <nusmv@fbk.eu>. ]

******************************************************************************/
#ifndef __TRACE_XML_LOADER_H
#define __TRACE_XML_LOADER_H

#if HAVE_CONFIG_H
# include "nusmv-config.h"
#endif

#include "TraceLoader.h"

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/
typedef struct TraceXmlLoader_TAG* TraceXmlLoader_ptr;

/*---------------------------------------------------------------------------*/
/* Variable declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Macro declarations                                                        */
/*---------------------------------------------------------------------------*/
#define TRACE_XML_LOADER(x) \
         ((TraceXmlLoader_ptr) x)

#define TRACE_XML_LOADER_CHECK_INSTANCE(x) \
         (nusmv_assert(TRACE_XML_LOADER(x) != TRACE_XML_LOADER(NULL)))

/**AutomaticStart*************************************************************/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/
EXTERN TraceXmlLoader_ptr
TraceXmlLoader_create ARGS((const char* xml_filename,
                            boolean halt_on_undefined_symbols,
                            boolean halt_on_wrong_section));

/**AutomaticEnd***************************************************************/

#endif /* __TRACE_XML__H */

